; License: The MIT License (MIT) Copyright (c) 2011..2012 Barend Gehrels

; Permission is hereby granted, free of charge, to any person obtaining a
; copy of this software and associated documentation files (the "Software"),
; to deal in the Software without restriction, including without limitation
; the rights to use, copy, modify, merge, publish, distribute, sublicense,
; and/or sell copies of the Software, and to permit persons to whom the
; Software is furnished to do so, subject to the following conditions:

; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.

; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
; DEALINGS IN THE SOFTWARE.

#define MyAppName "GrooveSharp"
#define MyAppVersion "0.1"
#define MyAppPublisher "Barend Gehrels"
#define MyAppURL "http://groovesharp.codeplex.com"
#define MyAppExeName "GrooveSharp.exe"

[Setup]
AppId=GrooveSharp
AppName={#MyAppName}
AppVersion={#MyAppVersion}
AppPublisher={#MyAppPublisher}
AppPublisherURL={#MyAppURL}
AppSupportURL={#MyAppURL}
AppUpdatesURL={#MyAppURL}
DefaultDirName={pf}\{#MyAppName}
DefaultGroupName={#MyAppName}
AllowNoIcons=yes
LicenseFile=..\Doc\license.txt
OutputDir=output
OutputBaseFilename=GrooveSharpSetup
Compression=lzma
SolidCompression=yes
WizardImageFile=GrooveSharpInstallLogo.bmp
WizardSmallImageFile=GrooveSharpInstallLogoSmall.bmp

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"
Name: "dutch"; MessagesFile: "compiler:Languages\Dutch.isl"
Name: "french"; MessagesFile: "compiler:Languages\French.isl"
Name: "german"; MessagesFile: "compiler:Languages\German.isl"
Name: "spanish"; MessagesFile: "compiler:Languages\Spanish.isl"

[Tasks]
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked
Name: "quicklaunchicon"; Description: "{cm:CreateQuickLaunchIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked; OnlyBelowVersion: 0,6.1

[Files]
Source: "..\Source\bin\Release\GrooveSharp.exe"; DestDir: "{app}\bin"; Flags: ignoreversion
Source: "..\Source\bin\Release\Log4Net.config"; DestDir: "{app}\bin"; Flags: ignoreversion
Source: "..\Source\bin\Release\GrooveSharp.vshost.exe"; DestDir: "{app}\bin"; Flags: ignoreversion
Source: "..\Source\bin\Release\GrooveSharp.vshost.exe.config"; DestDir: "{app}\bin"; Flags: ignoreversion
Source: "..\Source\bin\Release\System.Data.SQLite.dll"; DestDir: "{app}\bin"; Flags: ignoreversion
Source: "..\Source\bin\Release\taglib-sharp.dll"; DestDir: "{app}\bin"; Flags: ignoreversion
Source: "..\Source\bin\Release\log4net.dll"; DestDir: "{app}\bin"; Flags: ignoreversion
; NOTE: Don't use "Flags: ignoreversion" on any shared system files

[Icons]
Name: "{group}\{#MyAppName}"; Filename: "{app}\bin\{#MyAppExeName}"
Name: "{commondesktop}\{#MyAppName}"; Filename: "{app}\bin\{#MyAppExeName}"; Tasks: desktopicon
Name: "{userappdata}\Microsoft\Internet Explorer\Quick Launch\{#MyAppName}"; Filename: "{app}\bin\{#MyAppExeName}"; Tasks: quicklaunchicon

[Run]
Filename: "{app}\bin\{#MyAppExeName}"; Description: "{cm:LaunchProgram,{#StringChange(MyAppName, '&', '&&')}}"; Flags: nowait postinstall skipifsilent

[UninstallDelete]
Type: files; Name: "{commonappdata}\{#MyAppName}\{#MyAppName}.db"
Type: files; Name: "{commonappdata}\{#MyAppName}\{#MyAppName}.log"
Type: dirifempty; Name: "{commonappdata}\{#MyAppName}"

[Code]
function IsDotNetDetected(version: string; service: cardinal): boolean;
// Adapted from: http://www.kynosarges.de/DotNetVersion.html
// See also: http://stackoverflow.com/questions/199080/how-to-detect-what-net-framework-versions-and-service-packs-are-installed

// service -- Specify any non-negative integer for the required service pack level:
//    0               No service packs required
//    1, 2, etc.      Service pack 1, 2, etc. required
var
  key: string;
  install, serviceCount: cardinal;
  success: boolean;
begin
  key := 'SOFTWARE\Microsoft\NET Framework Setup\NDP\' + version;

  // Removed: things not related to V4
  success := RegQueryDWordValue(HKLM, key, 'Install', install);
  success := success and RegQueryDWordValue(HKLM, key, 'Servicing', serviceCount);
  result := success and (install = 1) and (serviceCount >= service);
end;

function InitializeSetup(): Boolean;
begin
  result := IsDotNetDetected('v4\Client', 0);
  if not result then
  begin
    MsgBox('{#MyAppName} requires Microsoft .NET Framework Version 4 Client Profile.'#13#13
        'Please use Windows Update to install this version,'#13
        'and then re-run the {#MyAppName} Setup.', mbInformation, MB_OK);
  end;
end;
