﻿// License: The MIT License (MIT) Copyright (c) 2011..2012 Barend Gehrels

// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

using System;
using System.Collections.Generic;

namespace GrooveSharp
{
    public class Track : Titled
    {
        public int Id { get; set; }

        public string FolderName { get; set; }
        public string FileName { get; set; }

        public int? DiscNumber { get; set; }
        public int? TrackNumber { get; set; }
        public int? TrackCount { get; set; }

        public int? Year { get; set; }

        public TimeSpan? Duration { get; set; }

        public int PathId { get; set; }
        public Int64? FileSize { get; set; }
        public bool IsDeleted { get; set; }

        public int? AlbumId { get; set; }
        public int? GenreId { get; set; }

        // The normal case:
        public int? ArtistId { get; set; }


        // The special case: (for e.g. "Under Pressure" by Queen/David Bowie)
        public SortedSet<int> ArtistIds { get; set; }

        public string ItunesPersistentId { get; set; }

    }
}
