﻿// License: The MIT License (MIT) Copyright (c) 2011..2012 Barend Gehrels

// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

using System;

namespace GrooveSharp
{
    public class UpdatePlayDates : IPlayer
    {
        private Play m_play = null;

        public void Play(TrackInfo info)
        {
            try
            {
                if (info.Id > 0)
                {
                    m_play = new Play() { PlayDate = DateTime.Now, TrackId = info.Id, UserId = Db.UserId() };
                    Db.Connection().Insert(m_play);
                }
            }
            catch (Exception e)
            {
                App.ReportException(e);
            }
        }

        public void Stop()
        {
            try
            {
                if (m_play != null)
                {
                    m_play.Span = DateTime.Now - m_play.PlayDate;
                    Db.Connection().Update(m_play);

                    m_play = null;
                }
            }
            catch (Exception e)
            {
                App.ReportException(e);
            }
        }
    }
}
