﻿// License: The MIT License (MIT) Copyright (c) 2011..2012 Barend Gehrels

// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.

using System;
using System.Collections.Generic;
using System.Data;
using Stormy;

namespace GrooveSharp
{
    public class CollectionItemMapper : ISelectable<CollectionItem>
    {
        public CollectionItem ApplySelect(IDataReader reader)
        {
            CollectionItem result = new CollectionItem();
            result.TrackId = reader.AsInteger("track_id").Value;

            int index = reader.GetOrdinal("track_id");
            for (int i = 0; i < index; i++)
            {
                result.Items.Add(reader[i].ToString());
            }

            string path = String.Format(@"{0}\{1}\{2}", reader["path_folder"], reader["folder_name"].ToString(), reader["file_name"].ToString());
            // Get rid of spurios double backslashes, \\, if any
            result.FileName = System.IO.Path.GetFullPath(path);

            return result;
        }
    }
}
